#include <common.h>
#include <asm/arch/bcm4760.h>

#define writel(VAL,REG) (*((volatile ulong *)(REG))) = VAL;
#define readl(REG) ((volatile ulong *)(REG))

void hw_watchdog_activate (unsigned int activate)
{
	writel(0x1ACCE551, WDT_R_WDOGLOCK_MEMADDR);

	if (activate == 1)
	{
		writel(0, WDT_R_WDOGCONTROL_MEMADDR);
		writel(0, WDT_R_WDOGINTCLR_MEMADDR);
		for (;;)
		{
			if (readl(WDT_R_WDOGRIS_SEL)) 
				break;
		}

		writel(CONFIG_HW_WATCHDOG_TIMER_LOAD_VALUE, WDT_R_WDOGLOAD_MEMADDR);
		writel((WDT_F_RESEN_MASK | WDT_F_INTEN_MASK), WDT_R_WDOGCONTROL_MEMADDR);
	}
	else
	{
		writel(0, WDT_R_WDOGCONTROL_MEMADDR);
	}
	writel(0, WDT_R_WDOGLOCK_MEMADDR);
}

void hw_watchdog_reset (void)
{
	writel(0x1ACCE551, WDT_R_WDOGLOCK_MEMADDR);
	writel(0, WDT_R_WDOGINTCLR_MEMADDR);
	
	for (;;)
	{
		if (readl(WDT_R_WDOGRIS_SEL)) 
			break;
	}

	writel(0, WDT_R_WDOGLOCK_MEMADDR);
}
