/*****************************************************************************
*  Copyright 2008 Broadcom Corporation.  All rights reserved.
*
*  Unless you and Broadcom execute a separate written software license
*  agreement governing use of this software, this software is licensed to you
*  under the terms of the GNU General Public License version 2, available at
*  http://www.gnu.org/copyleft/gpl.html (the "GPL").
*
*  Notwithstanding the above, under no circumstances may you combine this
*  software in any way with any other Broadcom software provided under a
*  license other than the GPL, without Broadcom's express prior written
*  consent.
*
*****************************************************************************/

#ifndef __ASM_ARCH_BCM_SDHCI_H
#define __ASM_ARCH_BCM_SDHCI_H

/*
 * SDHCI Registers/Fields
 */
#define SDHCI_SDMA_SYS_ADDR_LOFF				( SDM0_R_SDMASYSTEMADDRESS_SEL )

#define SDHCI_BLK_SIZE_WOFF						( SDM0_R_BLOCKSIZE_SEL )
#define     SDHCI_XFR_BLK_SIZE                  ( SDM0_F_TRANSFERBLOCKSIZE_MASK )
#define     SDHCI_HOST_SDMA_BUFFER_SIZE         ( SDM0_F_HOSTSDMABUFFERSIZE_MASK )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_4K		( 0 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_8K		( 1 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_16K		( 2 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_32K		( 3 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_64K		( 4 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_128K	( 5 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_256K	( 6 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define			SDHCI_HOST_SDMA_BUFFER_SIZE_512K	( 7 << SDM0_F_HOSTSDMABUFFERSIZE_R )
#define     SDHCI_XFR_BLK_SIZE_12               ( SDM0_F_TRANSFERBLOCKSIZE_12_MASK )

#define SDHCI_BLK_CNT_WOFF						( SDM0_R_BLOCKCOUNT_SEL )
#define SDHCI_ARGUMENT_LOFF						( SDM0_R_ARGUMENT_SEL )

#define SDHCI_CMD_XFER_MODE_LOFF				( SDM0_R_TRANSFERMODE_SEL )
#define SDHCI_XFER_MODE_WOFF					( SDM0_R_TRANSFERMODE_SEL )
#define		SDHCI_DMA_ENABLE					( SDM0_F_DMAENABLE_MASK )
#define		SDHCI_BLK_CNT_ENABLE				( SDM0_F_BLOCKCOUNTENABLE_MASK )
#define		SDHCI_ACMD12_ENABLE					( SDM0_F_AUTOCMD12ENABLE_MASK )
#define		SDHCI_DATA_XFER_DIRECTION			( SDM0_F_DATATRANSFERDIRECTIONSELECT_MASK )
#define			SDHCI_DATA_XFER_WRITE			( 0 << SDM0_F_DATATRANSFERDIRECTIONSELECT_R )
#define			SDHCI_DATA_XFER_READ			( 1 << SDM0_F_DATATRANSFERDIRECTIONSELECT_R )
#define		SDHCI_MULTI_BLK_SELECT				( SDM0_F_MULTI_SINGLEBLOCKSELECT_MASK )
#define			SDHCI_SINGLE_BLK				( 0 << SDM0_F_MULTI_SINGLEBLOCKSELECT_R )
#define			SDHCI_MULTI_BLK					( 1 << SDM0_F_MULTI_SINGLEBLOCKSELECT_R )
#define		SDHCI_CEATA_CMD_COMPLETE			( SDM0_F_CMD_COMP_ATA_MASK )
#define		SDHCI_SPI_MODE_ENABLE				( SDM0_F_SPI_MODE_MASK )

#define SDHCI_COMMAND_WOFF						( SDM0_R_COMMAND_SEL )
#define     SDHCI_RESP_TYPE                     ( SDM0_F_RESPONSETYPE_SELECT_MASK )
#define  		SDHCI_CMD_RESP_NONE				( 0x00 )
#define  		SDHCI_CMD_RESP_LONG				( 0x01 )
#define  		SDHCI_CMD_RESP_SHORT			( 0x02 )
#define  		SDHCI_CMD_RESP_SHORT_BUSY		( 0x03 )
#define     SDHCI_CMD_CRC_CHK_ENABLE            ( SDM0_F_COMMANDCRCCHECKENABLE_MASK )
#define     SDHCI_CMD_INDEX_CHK_ENABLE          ( SDM0_F_COMMANDINDEXCHECKENABLE_MASK )
#define     SDHCI_DATA_PRESENT                  ( SDM0_F_DATAPRESENTSELECT_MASK )
#define     SDHCI_CMD_TYPE                      ( SDM0_F_COMMANDTYPE_MASK )
#define     SDHCI_CMD_ACMD_INDEX                ( SDM0_F_COMMANDINDEX_MASK )

#define SDHCI_RESPONSE0_WOFF					( SDM0_R_RESPONSE1_0_SEL )
#define SDHCI_RESPONSE1_WOFF					( SDM0_R_RESPONSE1_0_SEL + 2 )
#define SDHCI_RESPONSE10_LOFF					( SDM0_R_RESPONSE1_0_SEL )
#define SDHCI_RESPONSE2_WOFF					( SDM0_R_RESPONSE3_2_SEL )
#define SDHCI_RESPONSE3_WOFF					( SDM0_R_RESPONSE3_2_SEL + 2 )
#define SDHCI_RESPONSE32_LOFF					( SDM0_R_RESPONSE3_2_SEL )
#define SDHCI_RESPONSE4_WOFF					( SDM0_R_RESPONSE5_4_SEL )
#define SDHCI_RESPONSE5_WOFF					( SDM0_R_RESPONSE5_4_SEL + 2 )
#define SDHCI_RESPONSE54_LOFF					( SDM0_R_RESPONSE5_4_SEL )
#define SDHCI_RESPONSE6_WOFF					( SDM0_R_RESPONSE7_6_SEL )
#define SDHCI_RESPONSE7_WOFF					( SDM0_R_RESPONSE7_6_SEL + 2 )
#define SDHCI_RESPONSE76_LOFF					( SDM0_R_RESPONSE7_6_SEL )

#define SDHCI_BUF_DATA_PORT_LOFF				( SDM0_R_BUFFERDATAPORT_SEL )

#define SDHCI_PRESENT_STATE_LOFF				( SDM0_R_PRESENTSTATE_SEL )
#define		SDHCI_CMD_INHIBIT_CMD				( SDM0_F_COMMANDIHIBIT_CMD_MASK )
#define		SDHCI_CMD_INHIBIT_DAT				( SDM0_F_COMMANDIHIBIT_DAT_MASK )
#define		SDHCI_DAT_LINE_ACTIVE				( SDM0_F_DATLINEACTIVE_MASK )
#define		SDHCI_WRITE_XFER_ACTIVE				( SDM0_F_WRITETRANSFERACTIVE_MASK )
#define		SDHCI_READ_XFER_ACTIVE				( SDM0_F_READTRASFERACTIVE_MASK )
#define		SDHCI_BUFFER_WRITE_ENABLE			( SDM0_F_BUFFERWRITEENABLE_MASK )
#define		SDHCI_BUFFER_READ_ENABLE			( SDM0_F_BUFFERREADENABLE_MASK )
#define		SDHCI_CARD_INSERTED					( SDM0_F_CARDINSERTED_MASK )
#define		SDHCI_CARD_STATE_STABLE				( SDM0_F_CARDSTATESTABLE_MASK )
#define		SDHCI_CARD_DETECT					( SDM0_F_CARDDETECTPINLEVEL_MASK )
#define		SDHCI_WRITE_PROTECT					( SDM0_F_WRITEPROTECTSWITCHPINLEVEL_MASK )
#define		SDHCI_DAT3_0_SIGNAL_LEVEL			( SDM0_F_DAT3_0LINESIGNALLEVEL_MASK )
#define		SDHCI_CMD_LINE_SIGNAL_LEVEL			( SDM0_F_CMDLINESGNALLEVEL_MASK )
#define		SDHCI_DAT7_4_SIGNAL_LEVEL			( SDM0_F_DAT7_4LINESIGNALLEVEL_MASK )

#define SDHCI_HOST_CTRL_BOFF					( SDM0_R_HOSTCONTROL_SEL )
#define		SDHCI_LED_CTRL						( SDM0_F_LEDCONTROL_MASK )
#define			SDHCI_LED_OFF					( 0 << SDM0_F_LEDCONTROL_R )
#define			SDHCI_LED_ON					( 1 << SDM0_F_LEDCONTROL_R )
#define		SDHCI_DATA_TRANSFER_WIDTH			( SDM0_F_DATATRANSFERWIDTHSD1ORSD4_MASK )
#define			SDHCI_DATA_TRANSFER_WIDTH_1BIT	( 0 << SDM0_F_DATATRANSFERWIDTHSD1ORSD4_R )
#define			SDHCI_DATA_TRANSFER_WIDTH_4BIT	( 1 << SDM0_F_DATATRANSFERWIDTHSD1ORSD4_R )
#define		SDHCI_HIGH_SPEED_ENABLE				( SDM0_F_HIGHSPEEDENABLE_MASK )
#define		SDHCI_DMA_SELECT					( SDM0_F_DMASELECT_MASK )
#define			SDHCI_DMA_SDMA					( 0 << SDM0_F_DMASELECT_R )
#define			SDHCI_DMA_32BIT_ADMA1			( 1 << SDM0_F_DMASELECT_R )
#define			SDHCI_DMA_32BIT_ADMA2			( 2 << SDM0_F_DMASELECT_R )
#define			SDHCI_DMA_64BIT_ADMA2			( 3 << SDM0_F_DMASELECT_R )
#define		SDHCI_SD_8BIT_MODE					( SDM0_F_SD8BITMODE_MASK )
#define		SDHCI_CARD_DETECT_TEST_LEVEL		( SDM0_F_CARDDETECTTESTLEVEL_MASK )
#define		SDHCI_CARD_DETECT_SIGNAL_DETECT		( SDM0_F_CARDDETECTSIGNALDETECTION_MASK )

#define SDHCI_POWER_CTRL_BOFF					( SDM0_R_POWERCONTROL_SEL )
#define		SDHCI_SDBUS_POWER					( SDM0_F_SDBUSPOWER_MASK )
#define		SDHCI_SDBUS_VOLTAGE					( SDM0_F_SDBUSVOLTAGESELECT_MASK )
#define			SDHCI_SDBUS_VOLTAGE_1_8V		( 5 << SDM0_F_SDBUSVOLTAGESELECT_R )
#define			SDHCI_SDBUS_VOLTAGE_3V			( 6 << SDM0_F_SDBUSVOLTAGESELECT_R )
#define			SDHCI_SDBUS_VOLTAGE_3_3V		( 7 << SDM0_F_SDBUSVOLTAGESELECT_R )

#define SDHCI_BLOCK_GAP_CTRL_BOFF				( SDM0_R_BLOCKGAPCONTROL_SEL )
#define		SDHCI_STOP_AT_BLOCK_GAP_REQ			( SDM0_F_STOPATBLOCKGAPREQUEST_MASK )
#define		SDHCI_CONTINUE_REQ					( SDM0_F_CONTINUEREQUEST_MASK )
#define		SDHCI_READ_WAIT_CTRL				( SDM0_F_READWAITCONTROL_MASK )
#define		SDHCI_INT_AT_BLOCK_GAP				( SDM0_F_INTERRUPTATBLOCKGAP_MASK )

#define SDHCI_WAKEUP_CTRL_BOFF					( SDM0_R_WAKEUPCONTROL_SEL )
#define		SDHCI_WAKEUP_CARD_EVENT_ENABLE		( SDM0_F_WAKEUPEVENTENABLEONCARD_MASK )
#define		SDHCI_WAKEUP_SDCARD_EVENT_ENABLE	( SDM0_F_WAKEUPEVENTENABLEONSDCARD_MASK )

#define SDHCI_CLOCK_CTRL_WOFF					( SDM0_R_CLOCKCONTROL_SEL )
#define SDHCI_TIMEOUT_CLOCK_CTRL_LOFF			( SDM0_R_CLOCKCONTROL_SEL )
#define		SDHCI_INTERNAL_CLOCK_ENABLE			( SDM0_F_INTERNALCLOCKENABLE_MASK )
#define		SDHCI_INTERNAL_CLOCK_STABLE			( SDM0_F_INTERNALCLOCKSTABLE_MASK )
#define		SDHCI_SD_CLOCK_ENABLE				( SDM0_F_SDCLOCKENABLE_MASK )
#define		SDHCI_SD_CLOCK_FREQ_SELECT			( SDM0_F_SDCLKFREQUENCYSELECT_MASK )
#define			SDHCI_SD_CLOCK_DIV_1			( 0x0000 )
#define			SDHCI_SD_CLOCK_DIV_2			( 0x0100 )
#define			SDHCI_SD_CLOCK_DIV_4			( 0x0200 )
#define			SDHCI_SD_CLOCK_DIV_8			( 0x0400 )
#define			SDHCI_SD_CLOCK_DIV_16			( 0x0800 )
#define			SDHCI_SD_CLOCK_DIV_32			( 0x1000 )
#define			SDHCI_SD_CLOCK_DIV_64			( 0x2000 )
#define			SDHCI_SD_CLOCK_DIV_128			( 0x4000 )
#define			SDHCI_SD_CLOCK_DIV_256			( 0x8000 )

#define SDHCI_TIMEOUT_CTRL_BOFF					( SDM0_R_TIMEOUTCONTROL_SEL )
#define     SDHCI_DATA_TIMEOUT_COUNTER          ( SDM0_F_DATATIMEOUTCOUNTERVALUE_MASK )

#define SDHCI_SW_RESET_BOFF						( SDM0_R_SWRESET_SEL )
#define		SDHCI_SW_RESET_ALL					( SDM0_F_SOFTWARERESETFORALL_MASK )
#define		SDHCI_SW_RESET_CMDLINE				( SDM0_F_SOFTWARERESETFORCMDLINE_MASK )
#define		SDHCI_SW_RESET_DATLINE				( SDM0_F_SOFTWARERESETFORDATLINE_MASK )

#define SDHCI_INT_STS_LOFF						( SDM0_R_NORMALINTERRUPTSTATUS_SEL )
#define SDHCI_INT_STS_EN_LOFF					( SDM0_R_NORMALINTERRUPTSTAT_EN_SEL )
#define SDHCI_INT_SIG_EN_LOFF					( SDM0_R_NORMALINTERRUPTSIGNALENABLE_SEL )
#define SDHCI_NORM_INT_STS_WOFF					( SDM0_R_NORMALINTERRUPTSTATUS_SEL )
#define SDHCI_NORM_INT_STS_EN_WOFF				( SDM0_R_NORMALINTERRUPTSTAT_EN_SEL )
#define SDHCI_NORM_INT_SIG_EN_WOFF				( SDM0_R_NORMALINTERRUPTSIGNALENABLE_SEL )
#define		SDHCI_CMD_COMPLETE					( SDM0_F_COMMANDCOMPLETE_MASK )
#define		SDHCI_XFER_COMPLETE					( SDM0_F_TRANSFERCOMPLETE_MASK )
#define		SDHCI_BLOCK_GAP_EVENT				( SDM0_F_BLOCKGAPEVENT_MASK )
#define		SDHCI_DMA_INT						( SDM0_F_DMAINTERRUPT_MASK )
#define		SDHCI_BUFFER_WRITE_READY			( SDM0_F_BUFFERWRITEREADY_MASK )
#define		SDHCI_BUFFER_READ_READY				( SDM0_F_BUFFERREADREADY_MASK )
#define		SDHCI_CARD_INSERTION				( SDM0_F_CARDINSERTION_MASK )
#define		SDHCI_CARD_REMOVAL					( SDM0_F_CARDREMOVAL_MASK )
#define		SDHCI_CARD_INT						( SDM0_F_CARDINTERRUPT_MASK )
#define		SDHCI_ERR_INT						( SDM0_F_ERRINTERRUPT_MASK )

#define SDHCI_ERR_INT_STS_WOFF					( SDM0_R_ERRINTERRUPTSTATUS_SEL )
#define SDHCI_ERR_INT_STS_EN_WOFF				( SDM0_R_ERRINTERRUPTSTAT_EN_SEL )
#define SDHCI_ERR_INT_SIG_EN_WOFF				( SDM0_R_ERRINTERRUPTSIGNALENABLE_SEL )
#define     SDHCI_CMD_TIMEOUT_ERR               ( SDM0_F_COMMANDTIMEOUTERR_MASK )
#define		SDHCI_CMD_CRC_ERR      				( SDM0_F_COMMANDCRCERR_MASK )
#define     SDHCI_CMD_END_BIT_ERR               ( SDM0_F_COMMANDENDBITERR_MASK )
#define     SDHCI_CMD_INDEX_ERR                 ( SDM0_F_COMMANDINDEXERR_MASK )
#define     SDHCI_DATA_TIMEOUT_ERR              ( SDM0_F_DATATIMEOUTERR_MASK )
#define     SDHCI_DATA_CRC_ERR                  ( SDM0_F_DATACRCERR_MASK )
#define     SDHCI_DATA_END_BIT_ERR              ( SDM0_F_DATAENDBITERR_MASK )
#define     SDHCI_CURRENT_LIMIT_ERR             ( SDM0_F_CURRENTLIMITERR_MASK )
#define     SDHCI_ACMD12_ERR                    ( SDM0_F_AUTOCMD12ERR_MASK )
#define     SDHCI_ADMA_ERR                      ( SDM0_F_ADMAERR_MASK )
#define     SDHCI_TARGET_RESP_ERR               ( SDM0_F_TARGETRESPONSEERR_MASK )
#define     SDHCI_CEATA_ERR                     ( SDM0_F_CEATAERRSIG_MASK )
#define     SDHCI_VENDOR_SPECIFIC_ERR           ( SDM0_F_VENDORSPECIFICERR_MASK )

#define SDHCI_ACMD12_ERR_STS_WOFF				( SDM0_R_AUTOCMD12ERRSTATUS_SEL )
#define		SDHCI_ACMD12_NOT_EXECUTED			( SDM0_F_AUTOCMD12NOTEXECUTED_MASK )
#define		SDHCI_ACMD12_TIMEOUT_ERR			( SDM0_F_AUTOCMD12TIMEOUTERR_MASK )
#define		SDHCI_ACMD12_CRC_ERR				( SDM0_F_AUTOCMD12CRCERR_MASK )
#define		SDHCI_ACMD12_END_BIT_ERR			( SDM0_F_AUTOCMD12ENDBITERR_MASK )
#define		SDHCI_ACMD12_INDEX_ERR				( SDM0_F_AUTOCMD12INDEXERR_MASK )
#define		SDHCI_CMD_NOT_ISSUED				( SDM0_F_COMMANDNOTISSUEDBYAUTOCMD12ERR_MASK )

#define SDHCI_CAPABILITIES_LOFF					( SDM0_R_CAPABILITIES_SEL )
#define		SDHCI_TIMEOUT_CLK_FREQ				( SDM0_F_TIMEOUTCLOCKFREQUENCY_MASK )
#define		SDHCI_TIMEOUT_CLK_UNIT				( SDM0_F_TIMEOUTCLOCKUNIT_MASK )
#define		SDHCI_BASE_SD_BLOCK_FREQ			( SDM0_F_BASECLOCKFREQUENCYFORSDCLOCK_MASK )
#define		SDHCI_MAX_BLOCK						( SDM0_F_MAXBLOCK_MASK )
#define			SDHCI_MAX_BLOCK_512				( 0 << SDM0_F_MAXBLOCK_R )
#define			SDHCI_MAX_BLOCK_1024			( 1 << SDM0_F_MAXBLOCK_R )
#define			SDHCI_MAX_BLOCK_2048			( 2 << SDM0_F_MAXBLOCK_R )
#define			SDHCI_MAX_BLOCK_4096			( 3 << SDM0_F_MAXBLOCK_R )
#define		SDHCI_EXT_MEDIA_BUS_SUPPORT			( SDM0_F_EXTENDEDMEDIABUSSUPPORT_MASK )
#define		SDHCI_ADMA2_SUPPORT					( SDM0_F_ASMA2SUPPORT_MASK )
#define		SDHCI_HIGH_SPEED_SUPPORT			( SDM0_F_HIGHSPEEDSUPPORT_MASK )
#define		SDHCI_SDMA_SUPPORT					( SDM0_F_SDMASUPPORT_MASK )
#define		SDHCI_SUSPEND_RESUME_SUPPORT		( SDM0_F_SUSPEND_RESUMESUPPORT_MASK )
#define		SDHCI_VOLTAGE_SUPPORT_3_3V			( SDM0_F_VOLTAGESUPPORT_3_3V_MASK )
#define		SDHCI_VOLTAGE_SUPPORT_3V			( SDM0_F_VOLTAGESUPPORT_3_V_MASK )
#define		SDHCI_VOLTAGE_SUPPORT_1_8V			( SDM0_F_VOLTAGESUPPORT_1_8_V_MASK )
#define		SDHCI_INT_MODE						( SDM0_F_INTERRUPTMODE_MASK )
#define		SDHCI_64BIT_SYS_BUS_SUPPORT			( SDM0_F_SDM0_F_64_BITSYSTEMBUSSUPPORT_MASK )
#define		SDHCI_SPI_MODE_SUPPORT				( SDM0_F_SPIMODE_MASK )
#define		SDHCI_SPI_BLOCK_MODE_SUPPORT		( SDM0_F_SPIBLOCKMODE_MASK )

#define SDHCI_MAX_CURRENT_CAPABILITIES_LOFF		( SDM0_R_MAXIMUMCURRENTCAPABILITIES )
#define		SDHCI_MAX_CURRENT_3_3V				( SDM0_F_MAX_CURR_FOR_3_3_V_MASK )
#define		SDHCI_MAX_CURRENT_3V				( SDM0_F_MAX_CURR_FOR_3_V_MASK )
#define		SDHCI_MAX_CURRENT_1_8V				( SDM0_F_MAX_CURR_FOR_1_8_V_MASK )

#define SDHCI_FORCE_EVENT_ACMD12_ERR_STS_WOFF	( SDM0_R_FORCEEVENTFORAUTOCMD12ERRSTATUS_SEL )
#define     SDHCI_ACMD_NOT_EXECUTED             ( SDM0_F_FORCEEVENTFORAUTOCMD12NOTEXECUTED_MASK )
#define     SDHCI_ACMD_TIMEOUT_ERR              ( SDM0_F_FORCEEVENTFORAUTOCMD12TIMEOUTERR_MASK )
#define     SDHCI_ACMD_CRC_ERR                  ( SDM0_F_FORCEEVENTFORAUTOCMD12CRCERR_MASK )
#define     SDHCI_ACMD_END_BIT_ERR              ( SDM0_F_FORCEEVENTFORAUTOCMD12ENDBITERR_MASK )
#define     SDHCI_ACMD_INDEX_ERR                ( SDM0_F_FORCEEVENTFORAUTOCMD12INDEXERR_MASK )
#define     SDHCI_ACMD_CMD_NOT_ISSUED           ( SDM0_F_FORCEEVENTFORCOMMANDNOTISSUEDBYAUTOCMD12ERR_MASK )

#define SDHCI_FORCE_EVENT_ERR_INT_STS_WOFF		( SDM0_R_FORCEEVENTFORERRINTERRUPTSTATUS_SEL )
#define		SDHCI_EVENT_CMD_TIMEOUT_ERR			( SDM0_F_FORCEEVENTFORCOMMANDTIMEOUTERR_MASK )
#define		SDHCI_EVENT_CMD_CRC_ERR				( SDM0_F_FORCEEVENTFORCOMMANDCRCERR_MASK )
#define		SDHCI_EVENT_CMD_END_BIT_ERR			( SDM0_F_FORCEEVENTFORCOMMANDENDBITERR_MASK )
#define		SDHCI_EVENT_CMD_INDEX_ERR			( SDM0_F_FORCEEVENTFORCOMMANDINDEXERR_MASK )
#define		SDHCI_EVENT_DATA_TIMEOUT_ERR		( SDM0_F_FORCEEVENTFORDATATIMEOUTERR_MASK )
#define		SDHCI_EVENT_DATA_CRC_ERR			( SDM0_F_FORCEEVENTFORDATACRCERR_MASK )
#define		SDHCI_EVENT_DATA_END_BIT_ERR		( SDM0_F_FORCEEVENTFORDATAENDBITERR_MASK )
#define		SDHCI_EVENT_CURRENT_LIMIT_ERR		( SDM0_F_FORCEEVENTFORCURRENTLIMITERR_MASK )
#define		SDHCI_EVENT_ACMD12_ERR				( SDM0_F_FORCEEVENTFORAUTOCMD12ERR_MASK )
#define		SDHCI_EVENT_CEATA_ERR				( SDM0_F_FORCEEVENTFORCEATAERR_MASK )
#define		SDHCI_EVENT_TARGET_RESP_ERR			( SDM0_F_FORCEEVENTFORTARGETRESPONSEERR_MASK )
#define		SDHCI_EVENT_CEATA_ERR				( SDM0_F_FORCEEVENTFORCEATAERR_MASK )
#define		SDHCI_EVENT_VENDOR_ERR_STS			( SDM0_F_FORCEEVENTFORVENDORSPECIFICERRSTATUS_MASK )

#define SDHCI_ADMA_ERR_STS_BOFF					( SDM0_R_ADMAERRSTATUS_SEL )
#define		SDHCI_ADMA_ERR_STATE				( SDM0_F_ADMAERRSTATE_MASK )
#define		SDHCI_ADMA_LEN_MISMATCH				( SDM0_F_ADMALENGTHMISMATCH_MASK )

#define SDHCI_ADMA_SYS_ADDR_LS_LOFF				( SDM0_R_ADMASYSTEMADDRESS_LOWER_SEL )
#define SDHCI_ADMA_SYS_ADDR_MS_LOFF				( SDM0_R_ADMASYSTEMADDRESS_UPPER_SEL )
#define SDHCI_BOOT_DATA_TIMEOUT_CTRL_LOFF		( 0x0060 )
#define SDHCI_DEBUG_SELECTION_BOFF				( 0x0064 )
#define SDHCI_CUSTOM_BOFF						( SDM0_R_CUSTOM_SEL )

#define SDHCI_SPI_INT_SUPPORT_WOFF				( SDM0_R_SPIINTERRUPTSUPPORT_SEL )

#define SDHCI_SLOT_INT_STS_WOFF					( SDM0_R_SLOTINTERRUPTSTATUS_SEL )
#define		SDHCI_INT_SIG_EACH_SLOT				( SDM0_F_INTERRUPTSIGNALFOREACHSLOT_MASK )

#define SDHCI_HOST_CTRLR_VERSION_WOFF			( SDM0_R_HOSTCONTROLLERVERSION_SEL )
#define     SDHCI_SPEC_VERSION                  ( SDM0_F_SPECIFICATIONVERSIONNUMBER_MASK )
#define     SDHCI_VENDOR_VERSION                ( SDM0_F_VENDORVERSIONUMBER_MASK )

#define SDHCI_F_OD					0x8001
#define SDHCI_F_PP					0x8005
#define SDHCI_F_OD_HS				0x0101
#define SDHCI_F_PP_HS				0x0105
#define SDHCI_F_OD_VHS				0x0001
#define SDHCI_F_PP_VHS				0x0005
#define SDHCI_F_OD_LS				0x0401
#define SDHCI_F_PP_LS				0x0405
#define SDHCI_INTERNAL_CLK_STABLE	(1 << 1) /* bit 1 */

#endif /* __ASM_ARCH_BCM_SDHCI_H */
